
#include "images2.h"

#include <qglobal.h>
#include <qdragobject.h>

#if QT_VERSION >= 0x040000
#include <Q3MimeSourceFactory>
#else
#include <qmime.h>
#endif


QPixmap Images2::icon(QString name, int size, bool png) {
	// qmake in windows has a "silly" bug. qmake creates an invalid file
	// if names start with "r", "n" or "t", so I appended an "x".
	if ( (name.startsWith("r")) || 
         (name.startsWith("t")) || 
         (name.startsWith("n")) ) 
	{
		name = "x" + name;
	}
	
	bool small=FALSE;

	if (name.endsWith("_small")) {
		small=TRUE;
		name = name.replace("_small", "");
	}

	if (png) name += ".png";
	QPixmap p;

	const QMimeSource *m= QMimeSourceFactory::defaultFactory()->data(name);
	if (m) {
	//if (QImageDrag::canDecode(m)) { 
		QImageDrag::decode(m,p);

		if (small) {
			p = resize(&p);
		}
		if (size!=-1) {
			p = resize(&p,size);
		}
	} else {
		qWarning("Images2::icon: icon '%s' not found", name.utf8().data());
	}
	return p;
}

QPixmap Images2::resize(QPixmap *p, int size) {
	QPixmap pix;
	pix.convertFromImage( (*p).convertToImage().smoothScale(size,size) );
	return pix;
}
